Normalised(
THEORY MagicNumberX IS
  MagicNumber(Machine(APDU))==(3.5)
END
&
THEORY UpperLevelX IS
  First_Level(Machine(APDU))==(Machine(APDU));
  Level(Machine(APDU))==(0)
END
&
THEORY LoadedStructureX IS
  Machine(APDU)
END
&
THEORY ListSeesX IS
  List_Sees(Machine(APDU))==(Constantes)
END
&
THEORY ListUsesX IS
  List_Uses(Machine(APDU))==(?)
END
&
THEORY ListIncludesX IS
  Inherited_List_Includes(Machine(APDU))==(?);
  List_Includes(Machine(APDU))==(?)
END
&
THEORY ListPromotesX IS
  List_Promotes(Machine(APDU))==(?)
END
&
THEORY ListExtendsX IS
  List_Extends(Machine(APDU))==(?)
END
&
THEORY ListVariablesX IS
  External_Context_List_Variables(Machine(APDU))==(?);
  Context_List_Variables(Machine(APDU))==(?);
  Abstract_List_Variables(Machine(APDU))==(?);
  Local_List_Variables(Machine(APDU))==(APDU_Le,APDU_Data,APDU_Lc,APDU_P2,APDU_P1,APDU_INS,APDU_CLA,APDU_StatusWord);
  List_Variables(Machine(APDU))==(APDU_Le,APDU_Data,APDU_Lc,APDU_P2,APDU_P1,APDU_INS,APDU_CLA,APDU_StatusWord);
  External_List_Variables(Machine(APDU))==(APDU_Le,APDU_Data,APDU_Lc,APDU_P2,APDU_P1,APDU_INS,APDU_CLA,APDU_StatusWord)
END
&
THEORY ListVisibleVariablesX IS
  Inherited_List_VisibleVariables(Machine(APDU))==(?);
  Abstract_List_VisibleVariables(Machine(APDU))==(?);
  External_List_VisibleVariables(Machine(APDU))==(?);
  Expanded_List_VisibleVariables(Machine(APDU))==(?);
  List_VisibleVariables(Machine(APDU))==(?);
  Internal_List_VisibleVariables(Machine(APDU))==(?)
END
&
THEORY ListInvariantX IS
  Gluing_Seen_List_Invariant(Machine(APDU))==(btrue);
  Gluing_List_Invariant(Machine(APDU))==(btrue);
  Expanded_List_Invariant(Machine(APDU))==(btrue);
  Abstract_List_Invariant(Machine(APDU))==(btrue);
  Context_List_Invariant(Machine(APDU))==(btrue);
  List_Invariant(Machine(APDU))==(APDU_StatusWord: TypesOfStatus & APDU_CLA: TypesOfCommandClass & APDU_INS: APDUCommands & APDU_P1: Int16 & APDU_P2: Int16 & APDU_Lc: Int8 & APDU_Lc: 0..256 & APDU_Data: Type_APDU_Data & APDU_Le: Int8)
END
&
THEORY ListAssertionsX IS
  Expanded_List_Assertions(Machine(APDU))==(btrue);
  Abstract_List_Assertions(Machine(APDU))==(btrue);
  Context_List_Assertions(Machine(APDU))==(btrue);
  List_Assertions(Machine(APDU))==(btrue)
END
&
THEORY ListInitialisationX IS
  Expanded_List_Initialisation(Machine(APDU))==(APDU_StatusWord:=APDU_ISOSW_Ok || @(APDU_CLA$0).(APDU_CLA$0: TypesOfCommandClass ==> APDU_CLA:=APDU_CLA$0) || @(APDU_INS$0).(APDU_INS$0: APDUCommands ==> APDU_INS:=APDU_INS$0) || @(APDU_P1$0).(APDU_P1$0: Int16 ==> APDU_P1:=APDU_P1$0) || @(APDU_P2$0).(APDU_P2$0: Int16 ==> APDU_P2:=APDU_P2$0) || APDU_Data:=(1..255)*{0} || APDU_Lc:=0 || APDU_Le:=0);
  Context_List_Initialisation(Machine(APDU))==(skip);
  List_Initialisation(Machine(APDU))==(APDU_StatusWord:=APDU_ISOSW_Ok || APDU_CLA:: TypesOfCommandClass || APDU_INS:: APDUCommands || APDU_P1:: Int16 || APDU_P2:: Int16 || APDU_Data:=(1..255)*{0} || APDU_Lc:=0 || APDU_Le:=0)
END
&
THEORY ListParametersX IS
  List_Parameters(Machine(APDU))==(?)
END
&
THEORY ListInstanciatedParametersX IS
  List_Instanciated_Parameters(Machine(APDU),Machine(Constantes))==(?)
END
&
THEORY ListConstraintsX IS
  List_Context_Constraints(Machine(APDU))==(btrue);
  List_Constraints(Machine(APDU))==(btrue)
END
&
THEORY ListOperationsX IS
  Internal_List_Operations(Machine(APDU))==(Set_APDU);
  List_Operations(Machine(APDU))==(Set_APDU)
END
&
THEORY ListInputX IS
  List_Input(Machine(APDU),Set_APDU)==(SW,CLA,INS,P1,P2,Lc,Data,Le)
END
&
THEORY ListOutputX IS
  List_Output(Machine(APDU),Set_APDU)==(?)
END
&
THEORY ListHeaderX IS
  List_Header(Machine(APDU),Set_APDU)==(Set_APDU(SW,CLA,INS,P1,P2,Lc,Data,Le))
END
&
THEORY ListPreconditionX IS
  List_Precondition(Machine(APDU),Set_APDU)==(SW: TypesOfStatus & CLA: TypesOfCommandClass & INS: APDUCommands & P1: Int16 & P2: Int16 & Lc: Int8 & Data: Type_APDU_Data & Le: Int8)
END
&
THEORY ListSubstitutionX IS
  Expanded_List_Substitution(Machine(APDU),Set_APDU)==(SW: TypesOfStatus & CLA: TypesOfCommandClass & INS: APDUCommands & P1: Int16 & P2: Int16 & Lc: Int8 & Data: Type_APDU_Data & Le: Int8 | APDU_StatusWord,APDU_CLA,APDU_INS,APDU_P1,APDU_P2,APDU_Lc,APDU_Data,APDU_Le:=SW,CLA,INS,P1,P2,Lc,Data,Le);
  List_Substitution(Machine(APDU),Set_APDU)==(APDU_StatusWord:=SW || APDU_CLA:=CLA || APDU_INS:=INS || APDU_P1:=P1 || APDU_P2:=P2 || APDU_Lc:=Lc || APDU_Data:=Data || APDU_Le:=Le)
END
&
THEORY ListConstantsX IS
  List_Valuable_Constants(Machine(APDU))==(?);
  Inherited_List_Constants(Machine(APDU))==(?);
  List_Constants(Machine(APDU))==(?)
END
&
THEORY ListSetsX IS
  Set_Definition(Machine(APDU),TypeTransactions)==({Trans_Credit,Trans_Debit,Trans_None});
  Context_List_Enumerated(Machine(APDU))==(StatesOfLife,TypesOfStatus,APDUCommands,TypesOfCommandClass,SecurityLevels,TypeTransactions);
  Context_List_Defered(Machine(APDU))==(?);
  Context_List_Sets(Machine(APDU))==(StatesOfLife,TypesOfStatus,APDUCommands,TypesOfCommandClass,SecurityLevels,TypeTransactions);
  List_Valuable_Sets(Machine(APDU))==(?);
  Inherited_List_Enumerated(Machine(APDU))==(?);
  Inherited_List_Defered(Machine(APDU))==(?);
  Inherited_List_Sets(Machine(APDU))==(?);
  List_Enumerated(Machine(APDU))==(?);
  List_Defered(Machine(APDU))==(?);
  List_Sets(Machine(APDU))==(?);
  Set_Definition(Machine(APDU),SecurityLevels)==({SecuLevel_Public,SecuLevel_Debit,SecuLevel_Credit,SecuLevel_CreditIdent,SecuLevel_Admin});
  Set_Definition(Machine(APDU),TypesOfCommandClass)==({APDU_CLA_DEMONEY,APDU_CLA_ISO,APDU_CLA_OP_80,APDU_CLA_OP_84,APDU_CLA_Reponse});
  Set_Definition(Machine(APDU),APDUCommands)==({APDU_INS_Select,APDU_INS_StoreData,APDU_INS_InitializeUpdate,APDU_INS_ExternalAuthentification,APDU_INS_GetData,APDU_INS_InitializeTransaction,APDU_INS_CompleteTransaction,APDU_INS_VerifyPIN,APDU_INS_Reponse});
  Set_Definition(Machine(APDU),TypesOfStatus)==({APDU_ISOSW_Err_AuthFailed,APDU_ISOSW_Err_PinFailed,APDU_ISOSW_Err_LcLengthFailed,APDU_ISOSW_Err_SecurityStatusFailed,APDU_ISOSW_Err_PinBlocked,APDU_ISOSW_Err_ConditionOfUseFailed,APDU_ISOSW_Err_IncorrectParams,APDU_ISOSW_Err_FunctionNotSupported,APDU_ISOSW_Err_RecordNotFound,APDU_ISOSW_Err_IncorrectLc,APDU_ISOSW_Err_IncorrectParamsP1P2,APDU_ISOSW_Err_DataReferenceFailed,APDU_ISOSW_Err_LeFailed,APDU_ISOSW_Err_InstructionNotSupported,APDU_ISOSW_Err_ClassNotSupported,APDU_ISOSW_Ok,APDU_DEMSW_ERR_MaxNumOfTransactionReached,APDU_DEMSW_ERR_CurrencyError,APDU_DEMSW_ERR_CreditTooHigh,APDU_DEMSW_ERR_DebitTooHigh,APDU_DEMSW_ERR_InvalidAmount});
  Set_Definition(Machine(APDU),StatesOfLife)==({Personalization,Processing})
END
&
THEORY ListHiddenConstantsX IS
  Abstract_List_HiddenConstants(Machine(APDU))==(?);
  Expanded_List_HiddenConstants(Machine(APDU))==(?);
  List_HiddenConstants(Machine(APDU))==(?);
  External_List_HiddenConstants(Machine(APDU))==(?)
END
&
THEORY ListPropertiesX IS
  Abstract_List_Properties(Machine(APDU))==(btrue);
  Context_List_Properties(Machine(APDU))==(Int8 = 0..255 & Int16 = -32768..32767 & APDU_Le_Reponse: Int8 & NbTransactionMaxiDansVieCarte: Int16 & NbTransactionMaxiDansVieCarte>=0 & TLV_Len = 1*7+1*7+4+2+2+2+2+16+16 & Type_APDU_Data = 1..255 --> NAT & SoldeMaxi: Int16 & SoldeMaxi>0 & MaxEssaisPIN: Int8 & MaxEssaisPIN>0 & StatesOfLife: FIN(INTEGER) & not(StatesOfLife = {}) & TypesOfStatus: FIN(INTEGER) & not(TypesOfStatus = {}) & APDUCommands: FIN(INTEGER) & not(APDUCommands = {}) & TypesOfCommandClass: FIN(INTEGER) & not(TypesOfCommandClass = {}) & SecurityLevels: FIN(INTEGER) & not(SecurityLevels = {}) & TypeTransactions: FIN(INTEGER) & not(TypeTransactions = {}));
  Inherited_List_Properties(Machine(APDU))==(btrue);
  List_Properties(Machine(APDU))==(btrue)
END
&
THEORY ListSeenInfoX IS
  Seen_Internal_List_Operations(Machine(APDU),Machine(Constantes))==(?);
  Seen_Context_List_Enumerated(Machine(APDU))==(?);
  Seen_Context_List_Invariant(Machine(APDU))==(btrue);
  Seen_Context_List_Assertions(Machine(APDU))==(btrue);
  Seen_Context_List_Properties(Machine(APDU))==(btrue);
  Seen_List_Constraints(Machine(APDU))==(btrue);
  Seen_List_Operations(Machine(APDU),Machine(Constantes))==(?);
  Seen_Expanded_List_Invariant(Machine(APDU),Machine(Constantes))==(btrue)
END
&
THEORY ListOfIdsX IS
  List_Of_Ids(Machine(APDU)) == (? | ? | APDU_Le,APDU_Data,APDU_Lc,APDU_P2,APDU_P1,APDU_INS,APDU_CLA,APDU_StatusWord | ? | Set_APDU | ? | seen(Machine(Constantes)) | ? | APDU);
  List_Of_HiddenCst_Ids(Machine(APDU)) == (? | ?);
  List_Of_VisibleCst_Ids(Machine(APDU)) == (?);
  List_Of_VisibleVar_Ids(Machine(APDU)) == (? | ?);
  List_Of_Ids_SeenBNU(Machine(APDU)) == (?: ?);
  List_Of_Ids(Machine(Constantes)) == (APDU_Le_Reponse,TLV_Len,NbTransactionMaxiDansVieCarte,Type_APDU_Data,SoldeMaxi,MaxEssaisPIN,Int8,Int16,StatesOfLife,TypesOfStatus,APDUCommands,TypesOfCommandClass,SecurityLevels,TypeTransactions,Personalization,Processing,APDU_ISOSW_Err_AuthFailed,APDU_ISOSW_Err_PinFailed,APDU_ISOSW_Err_LcLengthFailed,APDU_ISOSW_Err_SecurityStatusFailed,APDU_ISOSW_Err_PinBlocked,APDU_ISOSW_Err_ConditionOfUseFailed,APDU_ISOSW_Err_IncorrectParams,APDU_ISOSW_Err_FunctionNotSupported,APDU_ISOSW_Err_RecordNotFound,APDU_ISOSW_Err_IncorrectLc,APDU_ISOSW_Err_IncorrectParamsP1P2,APDU_ISOSW_Err_DataReferenceFailed,APDU_ISOSW_Err_LeFailed,APDU_ISOSW_Err_InstructionNotSupported,APDU_ISOSW_Err_ClassNotSupported,APDU_ISOSW_Ok,APDU_DEMSW_ERR_MaxNumOfTransactionReached,APDU_DEMSW_ERR_CurrencyError,APDU_DEMSW_ERR_CreditTooHigh,APDU_DEMSW_ERR_DebitTooHigh,APDU_DEMSW_ERR_InvalidAmount,APDU_INS_Select,APDU_INS_StoreData,APDU_INS_InitializeUpdate,APDU_INS_ExternalAuthentification,APDU_INS_GetData,APDU_INS_InitializeTransaction,APDU_INS_CompleteTransaction,APDU_INS_VerifyPIN,APDU_INS_Reponse,APDU_CLA_DEMONEY,APDU_CLA_ISO,APDU_CLA_OP_80,APDU_CLA_OP_84,APDU_CLA_Reponse,SecuLevel_Public,SecuLevel_Debit,SecuLevel_Credit,SecuLevel_CreditIdent,SecuLevel_Admin,Trans_Credit,Trans_Debit,Trans_None | ? | ? | ? | ? | ? | ? | ? | Constantes);
  List_Of_HiddenCst_Ids(Machine(Constantes)) == (? | ?);
  List_Of_VisibleCst_Ids(Machine(Constantes)) == (APDU_Le_Reponse,TLV_Len,NbTransactionMaxiDansVieCarte,Type_APDU_Data,SoldeMaxi,MaxEssaisPIN,Int8,Int16);
  List_Of_VisibleVar_Ids(Machine(Constantes)) == (? | ?);
  List_Of_Ids_SeenBNU(Machine(Constantes)) == (?: ?)
END
&
THEORY VariablesEnvX IS
  Variables(Machine(APDU)) == (Type(APDU_Le) == Mvl(btype(INTEGER,?,?));Type(APDU_Data) == Mvl(SetOf(btype(INTEGER,1,255)*btype(INTEGER,0,MAXINT)));Type(APDU_Lc) == Mvl(btype(INTEGER,?,?));Type(APDU_P2) == Mvl(btype(INTEGER,?,?));Type(APDU_P1) == Mvl(btype(INTEGER,?,?));Type(APDU_INS) == Mvl(etype(APDUCommands,?,?));Type(APDU_CLA) == Mvl(etype(TypesOfCommandClass,?,?));Type(APDU_StatusWord) == Mvl(etype(TypesOfStatus,?,?)))
END
&
THEORY OperationsEnvX IS
  Operations(Machine(APDU)) == (Type(Set_APDU) == Cst(No_type,etype(TypesOfStatus,?,?)*etype(TypesOfCommandClass,?,?)*etype(APDUCommands,?,?)*btype(INTEGER,?,?)*btype(INTEGER,?,?)*btype(INTEGER,?,?)*SetOf(btype(INTEGER,1,255)*btype(INTEGER,0,MAXINT))*btype(INTEGER,?,?)))
END
&
THEORY TCIntRdX IS
  predB0 == OK;
  extended_sees == KO;
  B0check_tab == KO;
  local_op == OK;
  abstract_constants_visible_in_values == KO
END
)
