Normalised(
THEORY MagicNumberX IS
  MagicNumber(Machine(Terminal))==(3.5)
END
&
THEORY UpperLevelX IS
  First_Level(Machine(Terminal))==(Machine(Terminal));
  Level(Machine(Terminal))==(0)
END
&
THEORY LoadedStructureX IS
  Machine(Terminal)
END
&
THEORY ListSeesX IS
  List_Sees(Machine(Terminal))==(Constantes)
END
&
THEORY ListUsesX IS
  List_Uses(Machine(Terminal))==(?)
END
&
THEORY ListIncludesX IS
  Inherited_List_Includes(Machine(Terminal))==(?);
  List_Includes(Machine(Terminal))==(?)
END
&
THEORY ListPromotesX IS
  List_Promotes(Machine(Terminal))==(?)
END
&
THEORY ListExtendsX IS
  List_Extends(Machine(Terminal))==(?)
END
&
THEORY ListVariablesX IS
  External_Context_List_Variables(Machine(Terminal))==(?);
  Context_List_Variables(Machine(Terminal))==(?);
  Abstract_List_Variables(Machine(Terminal))==(?);
  Local_List_Variables(Machine(Terminal))==(Erreur,CanalEstSecurise);
  List_Variables(Machine(Terminal))==(Erreur,CanalEstSecurise);
  External_List_Variables(Machine(Terminal))==(Erreur,CanalEstSecurise)
END
&
THEORY ListVisibleVariablesX IS
  Inherited_List_VisibleVariables(Machine(Terminal))==(?);
  Abstract_List_VisibleVariables(Machine(Terminal))==(?);
  External_List_VisibleVariables(Machine(Terminal))==(?);
  Expanded_List_VisibleVariables(Machine(Terminal))==(?);
  List_VisibleVariables(Machine(Terminal))==(?);
  Internal_List_VisibleVariables(Machine(Terminal))==(?)
END
&
THEORY ListInvariantX IS
  Gluing_Seen_List_Invariant(Machine(Terminal))==(btrue);
  Gluing_List_Invariant(Machine(Terminal))==(btrue);
  Expanded_List_Invariant(Machine(Terminal))==(btrue);
  Abstract_List_Invariant(Machine(Terminal))==(btrue);
  Context_List_Invariant(Machine(Terminal))==(btrue);
  List_Invariant(Machine(Terminal))==(CanalEstSecurise: BOOL & Erreur: BOOL)
END
&
THEORY ListAssertionsX IS
  Expanded_List_Assertions(Machine(Terminal))==(btrue);
  Abstract_List_Assertions(Machine(Terminal))==(btrue);
  Context_List_Assertions(Machine(Terminal))==(btrue);
  List_Assertions(Machine(Terminal))==(btrue)
END
&
THEORY ListInitialisationX IS
  Expanded_List_Initialisation(Machine(Terminal))==(CanalEstSecurise,Erreur:=FALSE,FALSE);
  Context_List_Initialisation(Machine(Terminal))==(skip);
  List_Initialisation(Machine(Terminal))==(CanalEstSecurise:=FALSE || Erreur:=FALSE)
END
&
THEORY ListParametersX IS
  List_Parameters(Machine(Terminal))==(?)
END
&
THEORY ListInstanciatedParametersX IS
  List_Instanciated_Parameters(Machine(Terminal),Machine(Constantes))==(?)
END
&
THEORY ListConstraintsX IS
  List_Context_Constraints(Machine(Terminal))==(btrue);
  List_Constraints(Machine(Terminal))==(btrue)
END
&
THEORY ListOperationsX IS
  Internal_List_Operations(Machine(Terminal))==(EmissionReset,EmissionSelect,EmissionGetData,EmissionStoreData,EmissionInitializeUpdate,EmissionExternalAuthentification,EmissionInitializeTransaction,EmissionCompleteTransaction,EmissionVerifyPIN,TraitementErreur);
  List_Operations(Machine(Terminal))==(EmissionReset,EmissionSelect,EmissionGetData,EmissionStoreData,EmissionInitializeUpdate,EmissionExternalAuthentification,EmissionInitializeTransaction,EmissionCompleteTransaction,EmissionVerifyPIN,TraitementErreur)
END
&
THEORY ListInputX IS
  List_Input(Machine(Terminal),EmissionReset)==(?);
  List_Input(Machine(Terminal),EmissionSelect)==(?);
  List_Input(Machine(Terminal),EmissionGetData)==(?);
  List_Input(Machine(Terminal),EmissionStoreData)==(?);
  List_Input(Machine(Terminal),EmissionInitializeUpdate)==(?);
  List_Input(Machine(Terminal),EmissionExternalAuthentification)==(?);
  List_Input(Machine(Terminal),EmissionInitializeTransaction)==(?);
  List_Input(Machine(Terminal),EmissionCompleteTransaction)==(?);
  List_Input(Machine(Terminal),EmissionVerifyPIN)==(?);
  List_Input(Machine(Terminal),TraitementErreur)==(?)
END
&
THEORY ListOutputX IS
  List_Output(Machine(Terminal),EmissionReset)==(?);
  List_Output(Machine(Terminal),EmissionSelect)==(?);
  List_Output(Machine(Terminal),EmissionGetData)==(?);
  List_Output(Machine(Terminal),EmissionStoreData)==(?);
  List_Output(Machine(Terminal),EmissionInitializeUpdate)==(?);
  List_Output(Machine(Terminal),EmissionExternalAuthentification)==(?);
  List_Output(Machine(Terminal),EmissionInitializeTransaction)==(?);
  List_Output(Machine(Terminal),EmissionCompleteTransaction)==(?);
  List_Output(Machine(Terminal),EmissionVerifyPIN)==(?);
  List_Output(Machine(Terminal),TraitementErreur)==(?)
END
&
THEORY ListHeaderX IS
  List_Header(Machine(Terminal),EmissionReset)==(EmissionReset);
  List_Header(Machine(Terminal),EmissionSelect)==(EmissionSelect);
  List_Header(Machine(Terminal),EmissionGetData)==(EmissionGetData);
  List_Header(Machine(Terminal),EmissionStoreData)==(EmissionStoreData);
  List_Header(Machine(Terminal),EmissionInitializeUpdate)==(EmissionInitializeUpdate);
  List_Header(Machine(Terminal),EmissionExternalAuthentification)==(EmissionExternalAuthentification);
  List_Header(Machine(Terminal),EmissionInitializeTransaction)==(EmissionInitializeTransaction);
  List_Header(Machine(Terminal),EmissionCompleteTransaction)==(EmissionCompleteTransaction);
  List_Header(Machine(Terminal),EmissionVerifyPIN)==(EmissionVerifyPIN);
  List_Header(Machine(Terminal),TraitementErreur)==(TraitementErreur)
END
&
THEORY ListPreconditionX IS
  List_Precondition(Machine(Terminal),EmissionReset)==(btrue);
  List_Precondition(Machine(Terminal),EmissionSelect)==(btrue);
  List_Precondition(Machine(Terminal),EmissionGetData)==(btrue);
  List_Precondition(Machine(Terminal),EmissionStoreData)==(btrue);
  List_Precondition(Machine(Terminal),EmissionInitializeUpdate)==(btrue);
  List_Precondition(Machine(Terminal),EmissionExternalAuthentification)==(btrue);
  List_Precondition(Machine(Terminal),EmissionInitializeTransaction)==(btrue);
  List_Precondition(Machine(Terminal),EmissionCompleteTransaction)==(btrue);
  List_Precondition(Machine(Terminal),EmissionVerifyPIN)==(btrue);
  List_Precondition(Machine(Terminal),TraitementErreur)==(btrue)
END
&
THEORY ListSubstitutionX IS
  Expanded_List_Substitution(Machine(Terminal),TraitementErreur)==(btrue | Erreur:=FALSE);
  Expanded_List_Substitution(Machine(Terminal),EmissionVerifyPIN)==(btrue | @(CanalEstSecurise$0).(CanalEstSecurise$0: BOOL ==> CanalEstSecurise:=CanalEstSecurise$0) || @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionCompleteTransaction)==(btrue | @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionInitializeTransaction)==(btrue | @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionExternalAuthentification)==(btrue | @(CanalEstSecurise$0).(CanalEstSecurise$0: BOOL ==> CanalEstSecurise:=CanalEstSecurise$0) || @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionInitializeUpdate)==(btrue | @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionStoreData)==(btrue | @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionGetData)==(btrue | @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionSelect)==(btrue | @(CanalEstSecurise$0).(CanalEstSecurise$0: BOOL ==> CanalEstSecurise:=CanalEstSecurise$0) || @(Erreur$0).(Erreur$0: BOOL ==> Erreur:=Erreur$0));
  Expanded_List_Substitution(Machine(Terminal),EmissionReset)==(btrue | CanalEstSecurise,Erreur:=FALSE,FALSE);
  List_Substitution(Machine(Terminal),EmissionReset)==(CanalEstSecurise:=FALSE || Erreur:=FALSE);
  List_Substitution(Machine(Terminal),EmissionSelect)==(CanalEstSecurise:: BOOL || Erreur:: BOOL);
  List_Substitution(Machine(Terminal),EmissionGetData)==(Erreur:: BOOL);
  List_Substitution(Machine(Terminal),EmissionStoreData)==(Erreur:: BOOL);
  List_Substitution(Machine(Terminal),EmissionInitializeUpdate)==(Erreur:: BOOL);
  List_Substitution(Machine(Terminal),EmissionExternalAuthentification)==(CanalEstSecurise:: BOOL || Erreur:: BOOL);
  List_Substitution(Machine(Terminal),EmissionInitializeTransaction)==(Erreur:: BOOL);
  List_Substitution(Machine(Terminal),EmissionCompleteTransaction)==(Erreur:: BOOL);
  List_Substitution(Machine(Terminal),EmissionVerifyPIN)==(CanalEstSecurise:: BOOL || Erreur:: BOOL);
  List_Substitution(Machine(Terminal),TraitementErreur)==(Erreur:=FALSE)
END
&
THEORY ListConstantsX IS
  List_Valuable_Constants(Machine(Terminal))==(?);
  Inherited_List_Constants(Machine(Terminal))==(?);
  List_Constants(Machine(Terminal))==(?)
END
&
THEORY ListSetsX IS
  Set_Definition(Machine(Terminal),TypeTransactions)==({Trans_Credit,Trans_Debit,Trans_None});
  Context_List_Enumerated(Machine(Terminal))==(StatesOfLife,TypesOfStatus,APDUCommands,TypesOfCommandClass,SecurityLevels,TypeTransactions);
  Context_List_Defered(Machine(Terminal))==(?);
  Context_List_Sets(Machine(Terminal))==(StatesOfLife,TypesOfStatus,APDUCommands,TypesOfCommandClass,SecurityLevels,TypeTransactions);
  List_Valuable_Sets(Machine(Terminal))==(?);
  Inherited_List_Enumerated(Machine(Terminal))==(?);
  Inherited_List_Defered(Machine(Terminal))==(?);
  Inherited_List_Sets(Machine(Terminal))==(?);
  List_Enumerated(Machine(Terminal))==(?);
  List_Defered(Machine(Terminal))==(?);
  List_Sets(Machine(Terminal))==(?);
  Set_Definition(Machine(Terminal),SecurityLevels)==({SecuLevel_Public,SecuLevel_Debit,SecuLevel_Credit,SecuLevel_CreditIdent,SecuLevel_Admin});
  Set_Definition(Machine(Terminal),TypesOfCommandClass)==({APDU_CLA_DEMONEY,APDU_CLA_ISO,APDU_CLA_OP_80,APDU_CLA_OP_84,APDU_CLA_Reponse});
  Set_Definition(Machine(Terminal),APDUCommands)==({APDU_INS_Select,APDU_INS_StoreData,APDU_INS_InitializeUpdate,APDU_INS_ExternalAuthentification,APDU_INS_GetData,APDU_INS_InitializeTransaction,APDU_INS_CompleteTransaction,APDU_INS_VerifyPIN,APDU_INS_Reponse});
  Set_Definition(Machine(Terminal),TypesOfStatus)==({APDU_ISOSW_Err_AuthFailed,APDU_ISOSW_Err_PinFailed,APDU_ISOSW_Err_LcLengthFailed,APDU_ISOSW_Err_SecurityStatusFailed,APDU_ISOSW_Err_PinBlocked,APDU_ISOSW_Err_ConditionOfUseFailed,APDU_ISOSW_Err_IncorrectParams,APDU_ISOSW_Err_FunctionNotSupported,APDU_ISOSW_Err_RecordNotFound,APDU_ISOSW_Err_IncorrectLc,APDU_ISOSW_Err_IncorrectParamsP1P2,APDU_ISOSW_Err_DataReferenceFailed,APDU_ISOSW_Err_LeFailed,APDU_ISOSW_Err_InstructionNotSupported,APDU_ISOSW_Err_ClassNotSupported,APDU_ISOSW_Ok,APDU_DEMSW_ERR_MaxNumOfTransactionReached,APDU_DEMSW_ERR_CurrencyError,APDU_DEMSW_ERR_CreditTooHigh,APDU_DEMSW_ERR_DebitTooHigh,APDU_DEMSW_ERR_InvalidAmount});
  Set_Definition(Machine(Terminal),StatesOfLife)==({Personalization,Processing})
END
&
THEORY ListHiddenConstantsX IS
  Abstract_List_HiddenConstants(Machine(Terminal))==(?);
  Expanded_List_HiddenConstants(Machine(Terminal))==(?);
  List_HiddenConstants(Machine(Terminal))==(?);
  External_List_HiddenConstants(Machine(Terminal))==(?)
END
&
THEORY ListPropertiesX IS
  Abstract_List_Properties(Machine(Terminal))==(btrue);
  Context_List_Properties(Machine(Terminal))==(Int8 = 0..255 & Int16 = -32768..32767 & APDU_Le_Reponse: Int8 & NbTransactionMaxiDansVieCarte: Int16 & NbTransactionMaxiDansVieCarte>=0 & TLV_Len = 1*7+1*7+4+2+2+2+2+16+16 & Type_APDU_Data = 1..255 --> NAT & SoldeMaxi: Int16 & SoldeMaxi>0 & MaxEssaisPIN: Int8 & MaxEssaisPIN>0 & StatesOfLife: FIN(INTEGER) & not(StatesOfLife = {}) & TypesOfStatus: FIN(INTEGER) & not(TypesOfStatus = {}) & APDUCommands: FIN(INTEGER) & not(APDUCommands = {}) & TypesOfCommandClass: FIN(INTEGER) & not(TypesOfCommandClass = {}) & SecurityLevels: FIN(INTEGER) & not(SecurityLevels = {}) & TypeTransactions: FIN(INTEGER) & not(TypeTransactions = {}));
  Inherited_List_Properties(Machine(Terminal))==(btrue);
  List_Properties(Machine(Terminal))==(btrue)
END
&
THEORY ListSeenInfoX IS
  Seen_Internal_List_Operations(Machine(Terminal),Machine(Constantes))==(?);
  Seen_Context_List_Enumerated(Machine(Terminal))==(?);
  Seen_Context_List_Invariant(Machine(Terminal))==(btrue);
  Seen_Context_List_Assertions(Machine(Terminal))==(btrue);
  Seen_Context_List_Properties(Machine(Terminal))==(btrue);
  Seen_List_Constraints(Machine(Terminal))==(btrue);
  Seen_List_Operations(Machine(Terminal),Machine(Constantes))==(?);
  Seen_Expanded_List_Invariant(Machine(Terminal),Machine(Constantes))==(btrue)
END
&
THEORY ListOfIdsX IS
  List_Of_Ids(Machine(Terminal)) == (? | ? | Erreur,CanalEstSecurise | ? | EmissionReset,EmissionSelect,EmissionGetData,EmissionStoreData,EmissionInitializeUpdate,EmissionExternalAuthentification,EmissionInitializeTransaction,EmissionCompleteTransaction,EmissionVerifyPIN,TraitementErreur | ? | seen(Machine(Constantes)) | ? | Terminal);
  List_Of_HiddenCst_Ids(Machine(Terminal)) == (? | ?);
  List_Of_VisibleCst_Ids(Machine(Terminal)) == (?);
  List_Of_VisibleVar_Ids(Machine(Terminal)) == (? | ?);
  List_Of_Ids_SeenBNU(Machine(Terminal)) == (?: ?);
  List_Of_Ids(Machine(Constantes)) == (APDU_Le_Reponse,TLV_Len,NbTransactionMaxiDansVieCarte,Type_APDU_Data,SoldeMaxi,MaxEssaisPIN,Int8,Int16,StatesOfLife,TypesOfStatus,APDUCommands,TypesOfCommandClass,SecurityLevels,TypeTransactions,Personalization,Processing,APDU_ISOSW_Err_AuthFailed,APDU_ISOSW_Err_PinFailed,APDU_ISOSW_Err_LcLengthFailed,APDU_ISOSW_Err_SecurityStatusFailed,APDU_ISOSW_Err_PinBlocked,APDU_ISOSW_Err_ConditionOfUseFailed,APDU_ISOSW_Err_IncorrectParams,APDU_ISOSW_Err_FunctionNotSupported,APDU_ISOSW_Err_RecordNotFound,APDU_ISOSW_Err_IncorrectLc,APDU_ISOSW_Err_IncorrectParamsP1P2,APDU_ISOSW_Err_DataReferenceFailed,APDU_ISOSW_Err_LeFailed,APDU_ISOSW_Err_InstructionNotSupported,APDU_ISOSW_Err_ClassNotSupported,APDU_ISOSW_Ok,APDU_DEMSW_ERR_MaxNumOfTransactionReached,APDU_DEMSW_ERR_CurrencyError,APDU_DEMSW_ERR_CreditTooHigh,APDU_DEMSW_ERR_DebitTooHigh,APDU_DEMSW_ERR_InvalidAmount,APDU_INS_Select,APDU_INS_StoreData,APDU_INS_InitializeUpdate,APDU_INS_ExternalAuthentification,APDU_INS_GetData,APDU_INS_InitializeTransaction,APDU_INS_CompleteTransaction,APDU_INS_VerifyPIN,APDU_INS_Reponse,APDU_CLA_DEMONEY,APDU_CLA_ISO,APDU_CLA_OP_80,APDU_CLA_OP_84,APDU_CLA_Reponse,SecuLevel_Public,SecuLevel_Debit,SecuLevel_Credit,SecuLevel_CreditIdent,SecuLevel_Admin,Trans_Credit,Trans_Debit,Trans_None | ? | ? | ? | ? | ? | ? | ? | Constantes);
  List_Of_HiddenCst_Ids(Machine(Constantes)) == (? | ?);
  List_Of_VisibleCst_Ids(Machine(Constantes)) == (APDU_Le_Reponse,TLV_Len,NbTransactionMaxiDansVieCarte,Type_APDU_Data,SoldeMaxi,MaxEssaisPIN,Int8,Int16);
  List_Of_VisibleVar_Ids(Machine(Constantes)) == (? | ?);
  List_Of_Ids_SeenBNU(Machine(Constantes)) == (?: ?)
END
&
THEORY VariablesEnvX IS
  Variables(Machine(Terminal)) == (Type(Erreur) == Mvl(btype(BOOL,?,?));Type(CanalEstSecurise) == Mvl(btype(BOOL,?,?)))
END
&
THEORY OperationsEnvX IS
  Operations(Machine(Terminal)) == (Type(TraitementErreur) == Cst(No_type,No_type);Type(EmissionVerifyPIN) == Cst(No_type,No_type);Type(EmissionCompleteTransaction) == Cst(No_type,No_type);Type(EmissionInitializeTransaction) == Cst(No_type,No_type);Type(EmissionExternalAuthentification) == Cst(No_type,No_type);Type(EmissionInitializeUpdate) == Cst(No_type,No_type);Type(EmissionStoreData) == Cst(No_type,No_type);Type(EmissionGetData) == Cst(No_type,No_type);Type(EmissionSelect) == Cst(No_type,No_type);Type(EmissionReset) == Cst(No_type,No_type))
END
&
THEORY TCIntRdX IS
  predB0 == OK;
  extended_sees == KO;
  B0check_tab == KO;
  local_op == OK;
  abstract_constants_visible_in_values == KO
END
)
